#!/usr/bin/env perl

use strict;
use warnings;

use CGI;
use HTML::TreeStructured;

my $q = CGI->new;

print $q->header(-type => 'text/html');
my $verbose = $q->param('verbose');

use Data::Dumper;
use H2O;

my $file = 'org.csv';

my $h = H2O::csv2hashref($file);
if ($verbose) {
	print '<pre>' . Dumper($h) . '</pre>';
}

my $org = H2O::h2o($h);
if ($verbose) {
	print '<pre>' . Dumper($org) . '</pre>';
}

print HTML::TreeStructured->new(
	       name         => 'tree_name',
	       image_path   => '/images/',
	       data         => $org,
	       title        => "My Tree",
	       title_width  => 300,
	       level        => {},     ### If scalar, close BEYOND this depth. Depth start at 0.
				       ### If Hash, close for depths specified in keys
)->output;

