#!/usr/bin/env perl

package MyPack;
 
use strict;
use warnings;

use Data::Dumper;

use H2O;
 
use Net::Server::PreForkSimple;
 
use vars qw(@ISA);
@ISA = qw(Net::Server::PreForkSimple);
 
my $tcp_port = 2014;
 
my $user = getpwuid($>);
 
print "\$Net::Server::VERSION = $Net::Server::VERSION\n";
 
### MyPack->run(port => "$tcp_port", log_level => 8, allow => '10.7.96.31', allow => '10.9.252.68');
 
### MyPack->run(port => "$tcp_port", log_level => 8, allow => '127.0.0.1');
 
MyPack->run(port => "$tcp_port|tcp", log_level => 4, max_servers => 2);
 
sub process_request
{
        my $self = shift;
	
	my $pid = $$;

	my $h = H2O::csv2hashref('org.csv');
	my $org = H2O::h2o($h, 1);

        eval {
                while(<STDIN>) {
                        s/\r?\n$//;
                        if ($_ =~ /^exit$/) {
                                print qq{>>> Exiting\r\n};
                                exit(0);
                        }
                        if ($_ =~ /^quit$/) {
                                print qq{>>> Quitting\r\n};
                                return;
                        }
                        my $res = undef;
 
                        $_ =~ /^\s*(.*?)\s*$/;
			my $match = $1;

                        if ($match =~ /^\d+$/) {
                                $res = int($match) + 1;
                        } else {
                                $res = Dumper($org->{$match});
                        }
                        print qq{[$pid]>>> $res ("$match")\r\n};
                }
        };
 
        if( $@ =~ /timed out/i ){
                print STDOUT "Sorry, Timed Out!!\r\n";
                return;
        }
}
